
Thumper References
==================

This folder contains local copies of certain important references. It is not necessary to
populate this folder but you may find it convenient to do so. These references are not included
in the repository because they are not artifacts of this project.

There are several RFCs of interest.

+ [RFC-3161](http://www.rfc-editor.org/rfc/rfc3161.txt) Internet X.509 Public Key Infrastructure
  Time-Stamp Protocol (TSP). This is the primary RFC that describes the protocol implemented by
  Thumper.

+ [RFC-3370](http://www.rfc-editor.org/rfc/rfc3370.txt) Cryptographic Message Syntax (CMS)
  Algorithms. Information about specific algorithms has been split off from the description of
  CMS itself. This allows the IETF to update to the two documents independently. This RFC is the
  latest CMS algorithms document (but see the update in RFC-5754).

+ [RFC-5652](http://www.rfc-editor.org/rfc/rfc5652.txt) Cryptographic Message Syntax (CMS). CMS
  describes the specific way in which encrypted and digitally signed data is represented in
  various IETF standards (including TSP).

+ [RFC-5754](http://www.rfc-editor.org/rfc/rfc5754.txt) Using SHA2 Algorithms with Cryptographic
  Message Syntax. This RFC updates RFC-3370 by providing details on using the SHA2 algorithm
  with CMS.

+ [RFC-5816](http://www.rfc-editor.org/rfc/rfc5816.txt) ESSCertIDv2 Update for RFC 3161.

Here are some papers related to this project.

+ [Design and Implementation of a RFC3161-Enhanced Time-Stamping Service](http://crypto.nknu.edu.tw/publications/2004IWAP.pdf)
  by Chung-Huang Yang, Chih-Ching Yeh, and Fang-Dar Chu.
